//+------------------------------------------------------------------+
//|                                                   TradeHedge.mq4 |
//|                                      Copyright  2008, Trader101 |
//|                                          trader101@optonline.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Trader101"
#property link      "trader101@optonline.net"

// Mods by sklods  Sell Buy include FILE 


// allow script to accept inputs from user
#property show_inputs

//user input
extern double    Lots = 0.1;
extern int       Slippage = 2;


// globals 
string mySymbol;
string postfix;

// trade management
double ask;
double bid;

string TradeComment="TradeHedgeBUYALL";
int MagicNumber=200809241653;


// used for verbose error logging
#include <stdlib.mqh>
#include <T101_SellBuyList1.mqh>

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int init()
  {
   OpenBuy(Buy_pair_1);
   OpenBuy(Buy_pair_2);
   OpenBuy(Buy_pair_3);
   OpenBuy(Buy_pair_4);
   OpenBuy(Buy_pair_5);
   OpenBuy(Buy_pair_6);
   OpenBuy(Buy_pair_7);
   OpenBuy(Sell_pair_1);
   OpenBuy(Sell_pair_2);
   OpenBuy(Sell_pair_3);
   OpenBuy(Sell_pair_4);
   OpenBuy(Sell_pair_5);
   OpenBuy(Sell_pair_6);
   OpenBuy(Sell_pair_7);
  }


int deinit()
  {
  }


int start()
  {
  }



//ENTRY LONG (buy, Ask) 
void OpenBuy(string mySymbol)
     {
      int      gle=0;
      int      ticket=0;
      
      double SL=0;
      double TP=0;
      int loopcount;

      loopcount=0;
      while(true)          
        {
         bid=MarketInfo(mySymbol,MODE_BID);
         ask=MarketInfo(mySymbol,MODE_ASK);

         // place order - NO TP OR SL
         ticket=OrderSend(mySymbol,OP_BUY,Lots,ask,Slippage,0,0,TradeComment,MagicNumber,White);
         gle=GetLastError();
         if(gle==0)
           {
            Print("BUY PLACED Ticket="+ticket+" Ask="+ask+" Lots="+Lots);
            break;
           }
          else 
           {
            Print("-----ERROR-----  Placing BUY order: Lots="+Lots+" SL="+SL+" TP="+TP+" Bid="+bid+" Ask="+ask+" ticket="+ticket+" Err="+gle+" "+ErrorDescription(gle)); 
            
            RefreshRates();
            Sleep(500);

            // give up after 10 tries (~5 seconds)
            loopcount++;
            if(loopcount>10)
              {
               Print("-----ERROR-----  Giving up on placing BUY order"); 
               return(gle);
              }
           }

        }//while - place order 

     }//BUYme




