//+------------------------------------------------------------------+
//|                                                   TradeHedge.mq4 |
//|                                      Copyright  2008, Trader101 |
//|                                          trader101@optonline.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Trader101"
#property link      "trader101@optonline.net"

// Mods by sklods  Sell Buy include FILE 


// allow script to accept inputs from user
#property show_inputs

//user input
extern double    Lots = 0.1;
extern int       Slippage = 2;
extern bool      isIBFXmini=false;

// globals 
string mySymbol;


// trade management
double ask;
double bid;

string TradeComment="TradeHedgeSELLALL";
int MagicNumber=200809241653;


// used for verbose error logging
#include <stdlib.mqh>
#include <T101_SellBuyList1.mqh>
/*
extern string Buy_currency_pairs = "----- List of Buy currency pairs -----";
extern string Buy_pair_1 = "CADJPY";// "USDJPY";   USDCHF
extern bool  Show_buy_direction_1 = true;
extern string Buy_pair_2 = "EURGBP";//  "EURUSD";
extern bool  Show_buy_direction_2 = true;

extern string Buy_pair_3 = "GBPUSD"; //  "EURCHF";
extern bool  Show_buy_direction_3 = true;

extern string Buy_pair_4 = "NZDUSD" ;//"GBPJPY";
extern bool  Show_buy_direction_4 = true;

extern string Buy_pair_5 = "EURJPY" ; //"USDCAD";
extern bool  Show_buy_direction_5 = true;

extern string Buy_pair_6 = "AUDJPY";// "CADJPY";
extern bool  Show_buy_direction_6 = true;

extern string Buy_pair_7 = "GBPJPY" ; //"AUDUSD";
extern bool  Show_buy_direction_7 = true;

extern string Sell_currency_pairs = "----- List of Sell currency pairs -----";
extern string Sell_pair_1 = "AUDUSD"; //"EURJPY";
extern bool  Show_sell_direction_1 = true;

extern string Sell_pair_2 = "NZDJPY"; // "GBPUSD";
extern bool  Show_sell_direction_2 = true;

extern string Sell_pair_3 = "CHFJPY"; //"EURGBP";
extern bool  Show_sell_direction_3 = true;

extern string Sell_pair_4 = "USDJPY";//"GBPCHF";
extern bool  Show_sell_direction_4 = true;

extern string Sell_pair_5 = "EURUSD";//"CHFJPY";
extern bool  Show_sell_direction_5 = true;

extern string Sell_pair_6 = "EURCHF";//"USDCHF";
extern bool  Show_sell_direction_6 = true;

extern string Sell_pair_7 = "GBPCHF";//"AUDJPY";
extern bool  Show_sell_direction_7 = true;
*/


//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int init()
  {

   OpenSell(Buy_pair_1);
   OpenSell(Buy_pair_2);
   OpenSell(Buy_pair_3);
   OpenSell(Buy_pair_4);
   OpenSell(Buy_pair_5);
   OpenSell(Buy_pair_6);
   OpenSell(Buy_pair_7);
   OpenSell(Sell_pair_1);
   OpenSell(Sell_pair_2);
   OpenSell(Sell_pair_3);
   OpenSell(Sell_pair_4);
   OpenSell(Sell_pair_5);
   OpenSell(Sell_pair_6);
   OpenSell(Sell_pair_7);

  }


int deinit()
  {
  }


int start()
  {
  }



//ENTRY SHORT (sell, Bid)
void OpenSell(string mySymbol)
     {
      int      gle=0;
      int      ticket=0;
      
      double SL=0;
      double TP=0;
      int loopcount;

      loopcount=0;
      while(true)
        {
         bid=MarketInfo(mySymbol,MODE_BID);
         ask=MarketInfo(mySymbol,MODE_ASK);

         ticket=OrderSend(mySymbol,OP_SELL,Lots,bid,Slippage,0,0,TradeComment,MagicNumber,Red);
         gle=GetLastError();
         if(gle==0)
           {
            Print("SELL PLACED Ticket="+ticket+" Bid="+bid+" Lots="+Lots);
            break;
           }
            else 
           {
            Print("-----ERROR-----  placing SELL order: Lots="+Lots+" SL="+SL+" TP="+TP+" Bid="+bid+" Ask="+ask+" ticket="+ticket+" Err="+gle+" "+ErrorDescription(gle)); 
                            
            RefreshRates();
            Sleep(500);

            loopcount++;
            if(loopcount>10)
              {
               Print("-----ERROR-----  Giving up on placing SELL order"); 
               return(gle);
              }
           }

        }//while

     }//SELLme


